{

raVen's strings processing functions
(c) 2000 by raVen
(c) portions by turbo power software

supported compilers: borland pascal 7.0, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rStrings;
interface
Uses Objects;
const
 MonthNameSE: Array[1..12] of String[3] = (
                                           'Jan','Feb','Mar','Apr',
                                           'May','Jun','Jul','Aug',
                                           'Sep','Oct','Nov','Dec'
                                          );
 MonthNameSR: Array[1..12] of String[3] = (
                                           '','','','',
                                           '','','','',
                                           '','','',''
                                          );
 DaysNameSE  : Array[1..7] of String[3] = (
                                           'Sun','Mon','Tue','Wed',
                                           'Thu','Fri','Sat'
                                          );
 DaysNameSR  : Array[1..7] of String[2] = (
                                           '','','','',
                                           '','',''
                                          );
 OSID = {$IfDef Dpmi}   '/D16' {$EnDif}
        {$IfDef Win32}  '/W32' {$EnDif}
        {$IfDef Os2}    '/OS2' {$EnDif}
        {$IfDef MsDos}  '/DOS' {$EnDif}
        {$IfDef Dpmi32} '/D32' {$EndIf};
 cr          : Char = #13;
 lf          : Char = #10;
 zr          : Char = #00;
 Space       : Char = #32;
 Tab         : Char = #09;
 Masyamba    : Char = '@';
 Slash       : Char = '/';
 BackSlash   : Char = '\';
 Bracket1    : Char = '(';
 Bracket2    : Char = ')';
 qBracket1   : Char = '[';
 qBracket2   : Char = ']';
 DualPoint   : Char = ':';
 CommaPoint  : Char = ';';
 Minus       : Char = '-';
 Point       : Char = '.';
 Comma       : Char = ',';
 Quote1      : Char = '"';
 Quote2      : Char = '''';
 Quote3      : Char = '`';
 Equation    : Char = '=';
 Bucks       : Char = '$';
 Excl        : Char = '!';
 Roof        : Char = '^';
 Lattice     : Char = '#';
 Percent     : Char = '%';
 Ampersand   : Char = '&';
 Star        : Char = '*';
 Twiddle     : Char = '~';
 Underline   : Char = '_';
 Plus        : Char = '+';
 Quest       : Char = '?';
 x_x         : String[3] = '*.*';
 FidoChars   : Set of Char = [':','/','.','@'];
 DosDelimSet : Set of Char = ['\',':',#0];
 SpaceChars  : Set of Char = [#32,#09];
 stdEOL      : Set of Char = [#13,#10];
 Digits: String[36] = '0123456789abcdefghijklmnopqrstuvwxyz';
{}
type
 CharSet = set of Char;
{}
 function  HexB(b: Byte): String;
 function  HexW(w: Word): String;
 function  HexL(l: Longint): String;
 function  HexPtr(p: Pointer): String;
 function  BinaryB(b: Byte): String;
 function  BinaryW(w: Word): String;
 function  BinaryL(l: Longint): String;
 function  OctalB(b: Byte): String;
 function  OctalW(w: Word): String;
 function  OctalL(l: Longint): String;
 function  FromDec(Num: Longint; Base, LeadZero: Byte): String;
 function  ToDec(Num: String; Base: Byte): Longint;
{}
 function  HasExtension(Name: String; var DotPos: Word): Boolean;
 function  ForceExtension(Name: String; Ext: String): String;
 function  JustFilename(PathName: String): String;
 function  JustName(PathName: String): String;
 function  JustExtension(Name: String): String;
 function  JustPathname(PathName: String): String;
 function  AddBackSlash(DirName: String): String;
 function  RemoveBackSlash(DirName: String): String;
{}
 function  PadCh(s: String; Ch: Char; Len: Byte): String;
 function  Pad(s: String; Len: Byte): String;
 function  LeftPadCh(s: String; Ch: Char; Len: Byte): String;
 function  LeftPad(s: String; Len: Byte): String;
 function  CenterCh(s: String; Ch: Char; Width: Byte): String;
 function  Center(s: String; Width: Byte): String;
 function  WordPosition(n: Byte; s: String; WordDelims: CharSet): Byte;
 function  WordCount(s: String; WordDelims: CharSet): Byte;
 function  ExtractWord(n: Byte; s: String; WordDelims: CharSet): String;
{}
 function  GetByWords(L: Longint): String;
 function  StrEq(Data1,Data2: Pointer; Len: Word; CS: Boolean): Boolean;
 function  FindStr(var f: file; SearchPattern: Pointer; PatternLength: Word; CS: Boolean): Longint;
 function  GetRunDir: String;
 function  NToC(Num: Longint): String;
 function  CToN(Str: String): Longint;
 function  UpCase(C: Char): Char;
 function  UpStr(s: String): String;
 function  LoCase(C: Char): Char;
 function  LoStr(s: String): String;
 function  Win2Dos(s: String): String;
 function  Dos2Win(s: String): String;
 function  StrRCopy(Dest, Source: pChar; MaxLen: Word): pChar;
 function  Reverse(s: String): String;
 function  CompName(const Src, Mask: String): Boolean;
 function  UUESize(var st: tStream): Longint;
 function  UUELines(var st: tStream): Longint;
{}
{$IfNDef VirtualPascal}
 procedure SetLength(var s: string; NewLen: byte);
{$EndIf}
 procedure TrimEnd(var S: string; Ch: CharSet);
 procedure TrimStart(var S: string; Ch: CharSet);
 function  Trim(s: String; Ch: CharSet): String;
 procedure NewInsert(Source: string; var s: string; Idx: Integer);
 procedure NewDelete(var s: string; Idx: Integer; Count: Integer);
 function  PosFrom(s1,s2: String; FromPos: Byte): Word;
{}
 procedure ReallocStr(var aas: pString; s: String);
 function  GetPS(const ps: pString): String;
 procedure StreamReadLn(var st: tStream; var s: string);
 procedure StreamWriteLn(var st: tStream; s,es: string);
 procedure StreamBackReadLn(var st: tStream; var s: string);
 procedure StreamReadLnAsAsciiZ(var st: tStream; var s: string);
 function  StreamFindStr(var st: tStream; SearchPattern: Pointer; PatternLength: Word; CS: Boolean): Longint;
{}
implementation
Uses Strings, rCommon;
{}
function HexB(b: Byte): String;
 begin
  HexB[0]:=#2;
  HexB[1]:=Digits[b shr 4 + 1];
  HexB[2]:=Digits[b and $F + 1];
 end;
{}
function HexW(W: Word): String;
 begin
  HexW[0]:=#4;
  HexW[1]:=Digits[Hi(w) shr 4 + 1];
  HexW[2]:=Digits[Hi(w) and $F + 1];
  HexW[3]:=Digits[Lo(w) shr 4 + 1];
  HexW[4]:=Digits[Lo(w) and $F + 1];
 end;
{}
type
 LongRec=record
  LowWord,HighWord: System.Word;
 end;
function HexL(l: Longint): String;
 begin
  with LongRec(l) do HexL:=HexW(HighWord)+HexW(LowWord);
 end;
{}
type
 OS = record
  O, S : Word;
 end;
function HexPtr(p: Pointer): String;
 begin
  {$IfDef VirtualPascal}
  HexPtr:=HexL(Longint(P));
  {$Else}
  HexPtr:=HexW(OS(P).S)+':'+HexW(OS(P).O);
  {$EndIf}
 end;
{}
function BinaryB(b: Byte): String;
 var
  i,n: Word;
 begin
  n:=1;
  BinaryB[0]:=#8;
  for i:=7 downto 0 do
   begin
    BinaryB[n]:=Digits[Ord(b and (1 shl i)<>0)+1];
    Inc(n);
   end;
 end;
{}
function BinaryW(w: Word): String;
 var
  i,n: Word;
 begin
  n:=1;
  BinaryW[0]:=#16;
  for i:=15 downto 0 do
   begin
    BinaryW[n]:=Digits[Ord(w and (1 shl i)<>0)+1];
    Inc(n);
   end;
 end;
{}
function BinaryL(l: Longint): String;
 var
  i: Longint;
  n: Byte;
 begin
  n:=1;
  BinaryL[0]:=#32;
  for i:=31 downto 0 do
   begin
    BinaryL[n]:=Digits[Ord(l and Longint(1 shl i)<>0)+1];
    Inc(n);
   end;
 end;
{}
function OctalB(b: Byte): String;
 var
  i: Word;
 begin
  OctalB[0]:=#3;
  for I:=0 to 2 do begin
    OctalB[3-I]:=Digits[B and 7 + 1];
    B:=B shr 3;
   end;
 end;
{}
function OctalW(w: Word): String;
 var
  i: Word;
 begin
  OctalW[0]:=#6;
  for I:=0 to 5 do
   begin
    OctalW[6-i]:=Digits[w and 7 + 1];
    w:=w shr 3;
   end;
 end;
{}
function OctalL(l: Longint): String;
 var
  i: Word;
 begin
  OctalL[0]:=#12;
  for i:=0 to 11 do
   begin
    OctalL[12-i]:=Digits[l and 7 + 1];
    l:=l shr 3;
   end;
 end;
{}
function FromDec(Num: Longint; Base, LeadZero: Byte): String;
 var
  i: Byte;
  Answer: string;
 begin
  FromDec:='';
  if not (Base in [2..36]) then exit;
  Answer:='';
  repeat
   i:=Num mod Base;
   Num:=Num div Base;
   Answer:=Digits[i+1]+Answer;
  until (Num=0);
  FromDec:=LeadZeroS(Answer,LeadZero);
 end;
{}
function ToDec(Num: String; Base: Byte): Longint;
 var
  i: Byte;
  Answer: LongInt;
 begin
  ToDec:=0;
  if not (Base in [2..36]) then exit;
  Answer:=0;
  for i:=1 to Byte(Num[0]) do Answer:=Answer*Base+(Pos(LoStr(Copy(Num,i,1)),Digits)-1);
  ToDec:=Answer;
 end;
{}
function HasExtension(Name: String; var DotPos: Word): Boolean;
 var
  i: Word;
 begin
  DotPos:=0;
  for i:=Length(Name) downto 1 do if (Name[I]='.') and (DotPos=0) then DotPos:=i;
  HasExtension:=(DotPos>0) and (Pos('\',Copy(Name,Succ(DotPos),64))=0);
 end;
{}
function ForceExtension(Name: String; Ext: String): String;
 var
  DotPos: Word;
 begin
  if HasExtension(Name,DotPos) then ForceExtension:=Copy(Name,1,DotPos)+Ext
  else if Name='' then ForceExtension:=''
  else ForceExtension:=Name+'.'+Ext;
 end;
{}
function JustExtension(Name: String): String;
 var
  DotPos: Word;
 begin
  if HasExtension(Name,DotPos) then JustExtension:=Copy(Name,Succ(DotPos),Length(Name))
  else JustExtension:='';
 end;
{}
function JustPathname(PathName: String): String;
 var
  i: Word;
 begin
  i:=Succ(Word(Length(PathName)));
  repeat
   Dec(i);
  until (PathName[i] in DosDelimSet) or (i=0);
  if i=0 then JustPathname:=''
  else if i=1 then JustPathName:=PathName[1]
  else if (PathName[i]='\') then
   begin
    if PathName[Pred(I)]=':' then JustPathname:=Copy(PathName,1,i)
    else JustPathname:=Copy(PathName,1,Pred(i));
   end
  else JustPathname:=Copy(PathName,1,i);
 end;
{}
function JustFilename(PathName: String): String;
 var
  i: Word;
 begin
  i:=Succ(Word(Length(PathName)));
  repeat
   Dec(i);
  until (PathName[i] in DosDelimSet) or (i=0);
  JustFilename:=Copy(PathName,Succ(i), 64);
 end;
{}
function JustName(PathName: String): String;
 var
  DotPos: Byte;
 begin
  PathName:=JustFileName(PathName);
  DotPos:=Pos('.', PathName);
  if DotPos > 0 then PathName:=Copy(PathName, 1, DotPos-1);
  JustName:=PathName;
 end;
{}
function PadCh(s: String; Ch: Char; Len: Byte): String;
 var
  o: String;
  SLen: Byte absolute s;
 begin
  if Length(s)>=Len then PadCh:=s
  else
   begin
    o[0]:=Chr(Len);
    Move(s[1],o[1],sLen);
    if sLen<255 then FillChar(o[Succ(sLen)],Len-sLen,Ch);
    PadCh:=o;
   end;
 end;
{}
function Pad(s: String; Len: Byte): String;
 begin
  Pad:=PadCh(s,' ',Len);
 end;
{}
function LeftPadCh(s: String; Ch: Char; Len: Byte): String;
 var
  o: String;
  sLen: Byte absolute s;
 begin
  if Length(s)>=Len then LeftPadCh:=s
  else if sLen<255 then
   begin
    o[0]:=Chr(Len);
    Move(s[1],o[Succ(Word(Len))-sLen],sLen);
    FillChar(o[1],Len-sLen,Ch);
    LeftPadCh:=o;
   end;
 end;
{}
function LeftPad(s: String; Len: Byte): String;
 begin
  LeftPad:=LeftPadCh(s,' ',Len);
 end;
{}
function CenterCh(s: String; Ch: Char; Width: Byte): String;
 var
  o: string;
  sLen: Byte absolute S;
 begin
  if sLen>=Width then CenterCh:=s else if sLen<255 then
   begin
    o[0]:=Chr(Width);
    FillChar(o[1],Width,Ch);
    Move(S[1],o[Succ((Width-SLen) shr 1)], sLen);
    CenterCh:=o;
   end;
 end;
{}
function Center(s: String; Width: Byte): String;
 begin
  Center:=CenterCh(s,' ',Width);
 end;
{}
function AddBackSlash(DirName: String): String;
 begin
  if DirName[Length(DirName)] in DosDelimSet then AddBackSlash:=DirName
  else AddBackSlash:=DirName+'\';
 end;
{}
function WordPosition(n: Byte; s: String; WordDelims: CharSet): Byte;
 var
  Count: Byte;
  i: Word;
  sLen: Byte absolute s;
 begin
  Count:=0;
  i:=1;
  WordPosition := 0;
  while (i<=sLen) and (Count<>n) do
   begin
    while (i<=sLen) and (s[I] in WordDelims) do Inc(i);
    if i<=sLen then Inc(Count);
    if Count<>n then while (i<=sLen) and not(s[I] in WordDelims) do Inc(I)
    else WordPosition:=i;
   end;
  end;
{}
function WordCount(S: String; WordDelims: CharSet): Byte;
 var
  Count: Byte;
  i: Word;
  sLen: Byte absolute s;
 begin
  Count:=0;
  i:=1;
  while i<=sLen do
   begin
    while (i<=sLen) and (s[I] in WordDelims) do Inc(I);
    if i<=sLen then Inc(Count);
    while (i<=sLen) and not(s[I] in WordDelims) do Inc(I);
   end;
  WordCount:=Count;
 end;
{}
function ExtractWord(n: Byte; s: String; WordDelims: CharSet): String;
 var
  i: Word;
  Len: Byte;
  sLen: Byte absolute s;
 begin
  Len:=0;
  I:=WordPosition(n,s,WordDelims);
  if i<>0 then while (i<=sLen) and not(s[I] in WordDelims) do
   begin
    Inc(Len);
    ExtractWord[Len]:=S[i];
    Inc(i);
   end;
  ExtractWord[0]:=Char(Len);
 end;
{}
function    GetByWords(L: Longint): String;
 const
  _1_2: array[1..2] of pChar = (' ',' ');
  _1_19: array[1..19] of pChar = (
                                  ' ',' ',
                                  ' ',' ',
                                  ' ',' ',
                                  'ᥬ ','ᥬ ',
                                  ' ',' ',
                                  ' ',' ',
                                  'ਭ ','ୠ ',
                                  '⭠ ','⭠ ',
                                  'ᥬ ','ᥬ ',
                                  '⭠ '
                                 );
 des: array[2..9] of pChar = (
                              ' ','ਤ ',
                              'ப ','줥 ',
                              '줥 ','ᥬ줥 ',
                              'ᥬ줥 ','ﭮ '
                             );
 hang: array[1..9] of pChar = (
                               ' ',' ',
                               ' ',' ',
                               ' ',' ',
                               'ᥬ ','ᥬ ',
                               ' '
                              );
  NameRub: array[1..3] of pChar = ('㡫 ','㡫 ','㡫 ');
  NameTho: array[1..3] of pChar = (' ',' ',' ');
  NameMil: array[1..3] of pChar = (' ',' ',' ');
  NameMrd: array[1..3] of pChar = (' ','ठ ','म ');
 var
  S,S1: String;
  Many: Byte;
 procedure Semantic(I: Longint; var Words: String; var Fem: Byte);
  begin
   Words:='';
   if I>=100 then
    begin
     Words:=Concat(Words,StrPas(hang[I div 100]));
     I:=I mod 100;
    end;
   if I>19 then
    begin
     Words:= Concat(Words,StrPas(des[I div 10]));
     I:=I mod 10;
    end;
    if I<>0 then if (I<3) and (Fem<>0) then Words:=Concat(Words,StrPas(_1_2[I]))
    else Words:=Concat( Words,StrPas(_1_19[I]));
    case I of
     1: Fem:=1;
     2..4: Fem:=2;
     else Fem:=3;
    end;
  end;
 begin
  S:='';
  if L>=1000000000 then
   begin
    Many:=0;
    Semantic(L div 1000000000,S1,Many);
    S:=Concat(S1,StrPas(NameMrd[Many]));
    L:=L mod 1000000000;
   end;
  if L >= 1000000 then
   begin
    Many:=0;
    Semantic(L div 1000000,S1,Many);
    S:=Concat(S1,StrPas(NameMil[Many]));
    L:=L mod 1000000;
   end;
  if L >= 1000 then
   begin
    Many:=1;
    SeMantic(L div 1000,S1,Many);
    S:=Concat(S,S1,StrPas(NameTho[Many]));
    L:=L mod 1000;
   end;
  if L>=1 then
   begin
    Many:=0;
    Semantic(L,S1,Many);
    S:=Concat(S,S1,StrPas(NameRub[Many]));
   end;
  GetByWords:=S;
 end;
{}
function    StrEq(Data1,Data2: Pointer; Len: Word; CS: Boolean): Boolean;
 type
  Arr = array[1..$FFFF] of Char;
 var
  x: Word;
  d1: ^Arr absolute Data1;
  d2: ^Arr absolute Data2;
 begin
  StrEq:=True;
  for x:=1 to Len do if d1^[x]<>d2^[x] then
   begin
    if not CS and (UpCase(d1^[x])=UpCase(d2^[x])) then Continue;
    StrEq:=false;
    exit;
   end;
 end;
{}
function    FindStr(var f: file; SearchPattern: Pointer; PatternLength: Word; CS: Boolean): Longint;
 const
  Size: Word = 16384;
 var
  Buffer: Pointer;
  Position: Longint;
  BufSize,NBlocks,i,j,Fake: Word;
 begin
  BufSize:=Size+PatternLength;
  GetMem(Buffer,BufSize);
  NBlocks:=((FileSize(f)-FilePos(f)) div size)+1;
  Position:=FilePos(f);
  for i:=1 to NBlocks do
   begin
    BlockRead(f,Buffer^,BufSize,Fake);
    for j:=0 to size do
     begin
{$IfDef Ver70}
      if StrEq(Ptr(Seg(Buffer^),Ofs(Buffer^)+j),SearchPattern,PatternLength,CS) then
{$EndIf}
{$IfDef VirtualPascal}
      if StrEq(Ptr(Ofs(Buffer^)+j),SearchPattern,PatternLength,CS) then
{$EndIf}
       begin
        FreeMem(Buffer,BufSize);
        if Position>FileSize(f) then Position:=-1;
        FindStr:=Position;
        Seek(f,Position+PatternLength);
        Exit;
       end;
      Inc(Position);
     end;
    Seek(f,FilePos(f)-PatternLength+1);
  end;
  FreeMem(Buffer,BufSize);
  FindStr:=-1;
 end;
{}
function    GetRunDir: String;
 begin
  GetRunDir:=JustPathName(ParamStr(0));
 end;
{}
function    NToC(Num: Longint): String;
 var
  St: String;
 begin
  Str(Num,St);
  NToC:=St;
 end;
{}
function    CToN(Str: String): Longint;
 var
  Nm: Longint;
  J: integer;
 begin
  Val(Str,Nm,J);
  CToN:=Nm;
 end;
{}
function UpCase(C: Char): Char;
 begin
  case c of
   'a'..'z': c:=chr(ord(c)-(97-65));
   ''..'': c:=chr(ord(c)-(160-128));
   ''..'': c:=chr(ord(c)-(224-144));
   '': c:='';
  end;
  UpCase:=c;
 end;
{}
function    UpStr(s: String): String;
 var
  x: Byte;
 begin
  for x:=1 to Length(s) do s[x]:=UpCase(s[x]);
  UpStr:=s;
 end;
{}
function LoCase(c: Char): Char;
 begin
  case c of
   'A'..'Z': c:=chr(ord(c)+(97-65));
   ''..'': c:=chr(ord(c)+(160-128));
   ''..'': c:=chr(ord(c)+(224-144));
   '': c:='';
  end;
  LoCase:=c;
 end;
{}
function    LoStr(s: String): String;
 var
  x: Byte;
 begin
  for x:=1 to Length(s) do s[x]:=LoCase(s[x]);
  LoStr:=s;
 end;
{}
function Win2Dos(s: String): String;
 var
  x: Integer;
 begin
  for x:=1 to Length(s) do case s[x] of
   #168      : inc(s[x],72);
   #184      : inc(s[x],57);
   #192..#239: dec(s[x],64);
   #240..#255: dec(s[x],16);
  end;
  Win2Dos:=s;
 end;
{}
function Dos2Win(s: String): String;
 var
  x: Integer;
 begin
  for x:=1 to Length(s) do case s[x] of
   #128..#175: inc(s[x],64);
   #224..#239: inc(s[x],16);
   #240      : dec(s[x],72);
   #241      : dec(s[x],57);
  end;
  Dos2Win:=s;
 end;
{}
function StrRCopy(Dest, Source: pChar; MaxLen: Word): pChar;
 begin
  Move(Source^,Dest^,MaxLen);
  StrRCopy:=Dest;
 end;
{}
function RemoveBackSlash(DirName: String): String;
 begin
  if DirName[Length(DirName)]='\' then
{$IfDef VirtualPascal}
  SetLength(DirName,Length(DirName)-1);
{$EndIf}
{$IfDef Ver70}
  Dec(DirName[0]);
{$EndIf}
  RemoveBackSlash:=DirName;
 end;
{}
function Reverse(s: String): String;
 var
  x: Longint;
 begin
{$IfDef Ver70}
  Reverse[0]:=s[0];
  for x:=1 to Length(s) do Reverse[Length(s)-x+1]:=s[x];
{$EndIf}
{$IfDef VirtualPascal}
  SetLength(Result,length(s));
  for x:=1 to Length(s) do Result[Length(s)-x+1]:=s[x];
{$EndIf}
 end;
{}
{
  CompName (WildEqu)
  (c) by Vladimir S. Lokhov <vsl@tula.net> <2:5022/18.14>, 1994-2000.
}
type
 tCheckWildcardStack = record
  Src, Mask: Byte;
 end;
function CompName(const Src, Mask: String): Boolean;
 var
  Stack: array[1..128] of tCheckWildcardStack;
  StackPointer,
  SrcPosition, MaskPosition,
  SrcLength, MaskLength: Byte;
 begin
  CompName:=False;
  if (not ((Src='') xor (Mask<>''))) then exit;
  MaskLength:=Length(Mask);
  SrcLength:=Length(Src);
  if (Mask[MaskLength]<>'*') then while (MaskLength>1) and (SrcLength>1) do
   begin
    if (Mask[MaskLength]='*') or (Mask[MaskLength]='?') then break;
    if (Mask[MaskLength]<>Src[SrcLength]) then exit;
    Dec(MaskLength);
    Dec(SrcLength);
   end;
  if (Mask[MaskLength]='*') then while (Mask[MaskLength-1]='*') and (MaskLength>1) do Dec(MaskLength);
  StackPointer:=0;
  SrcPosition:=1;
  MaskPosition:=1;
  while (SrcPosition<=SrcLength) and (MaskPosition<=MaskLength) do
   begin
    case Mask[MaskPosition] of
     '?':
      begin
       Inc(SrcPosition);
       Inc(MaskPosition);
      end;
     '*':
      begin
       if (MaskPosition=1) or (Mask[MaskPosition-1]<>'*') then Inc(StackPointer);
       Stack[StackPointer].Mask:=MaskPosition;
       Inc(MaskPosition);
       if (MaskPosition<=MaskLength) then if ((Mask[MaskPosition]<>'?') and (Mask[MaskPosition]<>'*')) then
       while (SrcPosition<=Length(Src)) and (Src[SrcPosition]<>Mask[MaskPosition]) do Inc(SrcPosition);
       Stack[StackPointer].Src:=SrcPosition+1;
      end;
     else if (Src[SrcPosition]=Mask[MaskPosition]) then
      begin
       Inc(SrcPosition);
       Inc(MaskPosition);
      end
     else
      begin
       if (StackPointer=0) then exit;
       SrcPosition:=Stack[StackPointer].Src;
       MaskPosition:=Stack[StackPointer].Mask;
       Dec(StackPointer)
      end;
    end;
    while (not ((SrcPosition<=SrcLength) xor (MaskPosition>MaskLength))) do
     begin
      if (MaskPosition>=MaskLength) and (Mask[MaskLength]='*') then break;
      if (StackPointer=0) then exit;
      SrcPosition:=Stack[StackPointer].Src;
      MaskPosition:=Stack[StackPointer].Mask;
      Dec(StackPointer)
     end;
   end;
  CompName:=True;
 end;
(*
 ...
{
 CmpName original C version by Eugene Roshal (from far code)
 Pascal version by raVen
}
function CompName(sp,ss: String; SkipPath: Boolean): Boolean;
 function StrPBrk(s1,s2: pChar): pChar;
  var
   x: Word;
   r: pChar;
  begin
   StrPBrk:=nil;
   for x:=0 to StrLen(s2)-1 do
    begin
     r:=StrScan(s1,s2[x]);
     if r<>nil then
      begin
       StrPBrk:=r;
       exit;
      end;
    end;
  end;
 function CmpName(pattern,s: pChar): Boolean;
  const
   depth: Integer = 0;
  var
   sc, patternc, rangec: Char;
   dot: pChar;
   CmpCode, match: Boolean;
  begin
   while true do
    begin
     sc:=UpCase(s[0]);
     patternc:=UpCase(pattern[0]);
     Inc(Pattern);
     case patternc of
      #0:
       begin
        CmpName:=sc=zr;
        exit;
       end;
      '?':
       begin
        if (sc=zr) then
         begin
          CmpName:=false;
          exit;
         end;
        Inc(s);
        continue;
       end;
      '*':
       begin
        if (not Boolean(pattern[0])) then
         begin
          CmpName:=true;
          exit;
         end;
        if (pattern[0]=Point) then
         begin
          if (pattern[1]=Star) and (pattern[2]=zr) and (depth=0) then
           begin
            CmpName:=true;
            exit;
           end;
          dot:=StrScan(s,Point);
          if (pattern[1]=zr) then
           begin
            CmpName:=(dot=nil) or (dot[1]=zr);
            exit;
           end;
          if (dot<>nil) then
           begin
            s:=dot;
            if (StrPBrk(pattern,'*?[')=nil) and (StrScan(s+1,Point)=nil) then
             begin
              CmpName:=(StrIComp(pattern+1,s+1)=0);
              exit;
             end;
           end;
         end;
        while (Boolean(s[0])) do
         begin
          Inc(depth);
          CmpCode:=CmpName(pattern,s);
          Inc(s);
          Dec(depth);
          if (CmpCode) then
           begin
            CmpName:=true;
            exit;
           end;
         end;
        CmpName:=false;
        exit;
       end;
       '[':
        begin
         if (StrScan(pattern,qBracket2)=nil) then
          begin
           if (patternc<>sc) then
            begin
             CmpName:=false;
             exit;
            end;
           break;
          end;
         if (Boolean(pattern[0]) and ((pattern+1)[0]=qBracket2)) then
          begin
           if (pattern<>s) then
            begin
             CmpName:=false;
             exit;
            end;
           Inc(pattern,2);
           Inc(s);
           continue;
          end;
         match:=False;
         rangec:=UpCase(pattern[0]);
         while (rangec<>zr) do
          begin
           Inc(Pattern);
           if (rangec=qBracket2) then if (match) then break else
            begin
             CmpName:=false;
             exit;
            end;
           if (match) then
            begin
             rangec:=UpCase(pattern[0]);
             continue;
            end;
           if (rangec=Minus) and ((pattern-2)[0]<>qBracket1) and (pattern[0]<>qBracket2) then
            begin
             match:=(sc<=UpCase(pattern[0])) and (UpCase((pattern-2)[0])<=sc);
             Inc(pattern);
            end
           else match:=(sc=rangec);
           rangec:=UpCase(pattern[0]);
          end;
         if (rangec=zr) then
          begin
           CmpName:=false;
           exit;
          end;
         Inc(s);
         continue;
        end;
       else
        begin
         if (patternc<>sc) then
          begin
           if (patternc=Point) and (sc=zr) {and not CmpNameSearchMode)} then
            begin
             CmpName:=(pattern[0]<>Point) and (CmpName(pattern,s));
             exit;
            end
           else
            begin
             CmpName:=false;
             exit;
            end;
          end;
         Inc(s);
         Continue;
        end;
      end;
     Inc(s);
    end;
  end;
 var
  p1,p2: pChar;
 begin
  if SkipPath then ss:=JustFileName(ss);
  GetMem(p1,Length(sp)+1);
  GetMem(p2,Length(ss)+1);
  StrPCopy(p1,sp);
  StrPCopy(p2,ss);
  CompName:=CmpName(p1,p2);
  FreeMem(p1,Length(sp)+1);
  FreeMem(p2,Length(ss)+1);
 end;
*)
(*
original version:
int CmpName(char *pattern,char *String,int skippath)
{
  char Stringc,patternc,rangec;
  int match;
  static int depth=0;

  if (skippath)
    String=PointToName(String);

  for (;; ++String)
  {
    Stringc=LocalUpper(*String);
    patternc=LocalUpper(*pattern++);
    switch (patternc)
    {
      case 0:
        return(Stringc==0);
      case '?':
        if (Stringc == 0)
          return(FALSE);

        break;
      case '*':
        if (!*pattern)
          return(TRUE);

        if (*pattern=='.')
        {
          if (pattern[1]=='*' && pattern[2]==0 && depth==0)
            return(TRUE);
          char *dot=strchr(String,'.');
          if (pattern[1]==0)
            return (dot==NULL || dot[1]==0);
          if (dot!=NULL)
          {
            String=dot;
            if (strpbrk(pattern,"*?[")==NULL && strchr(String+1,'.')==NULL)
              return(LocalStricmp(pattern+1,String+1)==0);
          }
        }

        while (*String)
        {
          depth++;
          int CmpCode=CmpName(pattern,String++,FALSE);
          depth--;
          if (CmpCode)
            return(TRUE);
        }
        return(FALSE);
      case '[':
        if (strchr(pattern,']')==NULL)
        {
          if (patternc != Stringc)
            return (FALSE);
          break;
        }
        if (*pattern && *(pattern+1)==']')
        {
          if (*pattern!=*String)
            return(FALSE);
          pattern+=2;
          break;
        }
        match = 0;
        while ((rangec = LocalUpper(*pattern++))!=0)
        {
          if (rangec == ']')
            if (match)
              break;
            else
              return(FALSE);
          if (match)
            continue;
          if (rangec == '-' && *(pattern - 2) != '[' && *pattern != ']')
          {
            match = (Stringc <= LocalUpper(*pattern) &&
                     LocalUpper(*(pattern - 2)) <= Stringc);
            pattern++;
          }
          else
            match = (Stringc == rangec);
        }
        if (rangec == 0)
          return(FALSE);
        break;
      default:
        if (patternc != Stringc)
          if (patternc=='.' && Stringc==0 && !CmpNameSearchMode)
            return(*pattern!='.' && CmpName(pattern,String));
          else
            return(FALSE);
        break;
    }
  }
}
*)
{}
function UUESize(var st: tStream): Longint;
 const
  cctrl: Longint = 12;
 var
  spos,os,uuline,uusize,MaxSize: Longint;
  s,ostring: String;
  cc: Char;
  cs: Byte;
 begin
  UUESize:=0;
  if (@st=nil) then exit;
  uuline:=0;
  os:=0;
  MaxSize:=0;
  uusize:=0;
  ostring:='';
  spos:=st.GetPos;
  st.Seek(0);
  while (st.GetSize<>st.GetPos) do
   begin
    StreamReadLn(st,s);
    s:=Trim(s,SpaceChars);
    if (s='') then continue;
    cc:=s[1];
    cs:=Length(s);
    if (Pos(Space,s)=0) then
     begin
      if (os=cs) then if (ostring<>s) then
       begin
        Inc(uuline);
        Inc(uusize,Length(s));
       end
      else uuline:=uuline div 2;
      if ((Byte(cc)-((((cs-1)*3)/4)-32))-64=0) then
       begin
        Inc(uuline);
        Inc(uusize,Length(s));
       end;
     end
    else
     begin
      if (uuline>cctrl) then Inc(MaxSize,uusize);
      uuline:=0;
      uusize:=0;
     end;
   end;
  st.Seek(spos);
  if (MaxSize=0) then UUESize:=uusize else UUESize:=MaxSize;
 end;
{}
function UUELines(var st: tStream): Longint;
 const
  cctrl: Longint = 12;
 var
  spos,os,uuline,MaxLines: Longint;
  s,ostring: String;
  cc: Char;
  cs: Byte;
 begin
  UUELines:=0;
  if (@st=nil) then exit;
  uuline:=0;
  os:=0;
  MaxLines:=0;
  ostring:='';
  spos:=st.GetPos;
  st.Seek(0);
  while (st.GetSize<>st.GetPos) do
   begin
    StreamReadLn(st,s);
    s:=Trim(s,SpaceChars);
    if (s='') then continue;
    cc:=s[1];
    cs:=Length(s);
    if (Pos(Space,s)=0) then
     begin
      if (os=cs) then if (ostring<>s) then Inc(uuline) else uuline:=uuline div 2;
      if ((Byte(cc)-((((cs-1)*3)/4)-32))-64=0) then Inc(uuline);
     end
    else
     begin
      if (uuline>cctrl) then Inc(MaxLines,uuline);
      uuline:=0;
     end;
   end;
  st.Seek(spos);
  if (MaxLines=0) then UUELines:=uuline else UUELines:=MaxLines;
 end;
{}
{$IfNDef VirtualPascal}
procedure   SetLength(var s: string; NewLen: byte);
 begin
  s[0]:=Char(NewLen);
 end;
{$EndIf}
{}
procedure   TrimEnd(var S: string; Ch: CharSet);
 begin
  if Length(s)<=0 then exit;
  while S[Length(s)] in ch do
  SetLength(s,Length(s)-1);
 end;
{}
procedure   TrimStart(var S: string; Ch: CharSet);
 var
  p: byte;
 begin
  if Length(s)<=0 then exit;
  p:=1;
  while (s[p] in ch) and (p<=Length(s)) do Inc(p);
  if p>1 then
   begin
    move(s[p],s[1],succ(length(s)) - p);
    SetLength(s,Length(s)-pred(p));
   end;
 end;
{}
function    Trim(s: String; Ch: CharSet): String;
 begin
  TrimStart(s,Ch);
  TrimEnd(s,Ch);
  Trim:=s;
 end;
{}
procedure   NewInsert(Source: string; var s: string; Idx: Integer);
 begin
  if Length(Source)+Length(s)>255 then SetLength(s,255-Length(Source));
  Move(s[Idx],s[Idx+Length(Source)],Succ(Length(s))-Idx);
  Move(Source[1],s[Idx],Length(Source));
  SetLength(s,Length(s)+Length(Source));
 end;
{}
procedure   NewDelete(var s: string; Idx: Integer; Count: Integer);
 begin
  if (Idx<1) or (count<1) then exit;
  if (Abs(Length(s)-Idx)<Count) then Count:=Abs(Idx-Length(s))+1;
  Move(s[Idx+Count],s[Idx],Succ(Length(s)-Idx-Count));
  SetLength(s,Length(s)-Count);
 end;
{}
function  PosFrom(s1,s2: String; FromPos: Byte): Word;
 var
  ss: String;
  r: Byte;
 begin
  PosFrom:=0;
  if (FromPos<=0) then FromPos:=1;
  if (FromPos>Length(s2)) then exit;
  ss:=Copy(s2,FromPos,Length(s2));
  r:=Pos(s1,ss);
  if r<>0 then PosFrom:=r+FromPos-1;
 end;
{}
procedure ReallocStr(var aas: pString; s: String);
 begin
  if (aas<>nil) and (GetPS(aas)<>'') then DisposeStr(aas);
  aas:=nil;
  if s<>'' then aas:=NewStr(s);
 end;
{}
function  GetPS(const ps: pString): String;
 begin
  if ps<>nil then GetPS:=ps^ else GetPS:='';
 end;
{}
procedure   StreamReadLn(var st: tStream; var s: string);
 var
  c,c1: Char;
 begin
  if @st=nil then Exit;
  s:='';
  repeat
   st.Read(c,1);
   if (st.Status=stOK) and (c<>cr) and (c<>lf) then s:=s+c;
  until ((st.Status<>stOK) or (c=cr) or (c=lf));
  if st.Status=stOK then
   begin
    st.Read(c1,1);
    if ((c=lf) and (c1<>cr)) or ((c=cr) and (c1<>lf)) then st.Seek(st.GetPos-1);
   end;
  if st.Status<>0 then
   begin
    st.Reset;
    st.Seek(st.GetSize);
   end;
 end;
{}
procedure   StreamWriteLn(var st: tStream; s,es: string);
 begin
  if @st=nil then Exit;
  if s<>'' then st.Write(s[1],Length(s));
  if es<>'' then st.Write(es[1],Length(es));
 end;
{}
procedure   StreamBackReadLn(var st: tStream; var s: string);
 procedure bcRead(var q: tStream; var c: Char);
  begin
   q.Seek(q.GetPos-1);
   q.Read(c,1);
   q.Seek(q.GetPos-1);
  end;
 var
  c,c1: Char;
 begin
  s:='';
  if @st=nil then exit;
  if st.Status<>0 then exit;
  if st.GetPos>0 then repeat
   bcRead(st,c);
   if (st.Status=stOK) and (c<>cr) and (c<>lf) then s:=c+s;
  until ((st.Status<>stOK) or (st.GetPos=0) or (c=cr) or (c=lf));
  if st.Status=stOK then
   begin
    bcRead(st,c1);
    if ((c=lf) and (c1<>cr)) or ((c=cr) and (c1<>lf)) then st.Seek(st.GetPos+1);
   end;
  if st.Status<>0 then
   begin
    st.Reset;
    st.Seek(st.GetSize);
   end;
 end;
{}
procedure   StreamReadLnAsAsciiZ(var st: TStream; var s: string);
 var
  c,c1: Char;
 begin
  if @st=nil then Exit;
  s:='';
  repeat
   st.Read(c,1);
   if (c<>zr) and (c<>cr) then s:=s+c;
  until ((st.Status<>stOK) or (c=zr) or (c=cr));
  if st.Status<>0 then
   begin
    st.Reset;
    st.Seek(st.GetSize);
   end;
 end;
{}
function    StreamFindStr(var st: TStream; SearchPattern: Pointer; PatternLength: Word; CS: Boolean): Longint;
 const
  FindSize: Word = 32768;
 var
  FindBuffer: Pointer;
  FindPos: LongInt;
  FindBufSize,NBlocks,i,j,ForFree: Word;
 begin
  if @st=nil then Exit;
  FindBufSize:=FindSize+PatternLength;
  ForFree:=FindBufSize;
  GetMem(FindBuffer,ForFree);
  NBlocks:=((st.GetSize-st.GetPos) div FindSize)+1;
  FindPos:=st.GetPos;
  for i:=1 to NBlocks do
   begin
    if (st.GetSize-st.GetPos<FindBufSize) then FindBufSize:=st.GetSize-st.GetPos;
    st.Read(FindBuffer^,FindBufSize);
    for j:=0 to FindSize do
     begin
{$IfDef Ver70}
      if StrEq(Ptr(Seg(FindBuffer^),Ofs(FindBuffer^)+j),SearchPattern,PatternLength,CS) then
{$EndIf}
{$IfDef VirtualPascal}
      if StrEq(System.Ptr(System.Ofs(FindBuffer^)+j),SearchPattern,PatternLength,CS) then
{$EndIf}
       begin
        FreeMem(FindBuffer,ForFree);
        if FindPos>st.GetSize then FindPos:=-1;
        StreamFindStr:=FindPos;
        st.Seek(FindPos+PatternLength);
        Exit;
       end;
      Inc(FindPos);
     end;
    st.Seek(st.GetPos-PatternLength+1);
  end;
  FreeMem(FindBuffer,ForFree);
  StreamFindStr:=-1;
 end;
{}
end.
