{


squish fido library
(c) 1999-2000 by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rSquish;
interface
Uses Objects, rAbs;
{}
const
{}
 SqDataExt     : String[4] = '.sqd';
 SqIndexExt    : String[4] = '.sqi';
 SqLastReadExt : String[4] = '.sql';
 SqID          : Longint   = $AFAE4453;
 sqnflRcv      : Longint   = $00080000;
{}
type
{}
 tSquishBaseHdr = record
  Len        : System.Word;            {   ᪢ (0x100) }
  Rsvd1      : System.Word;            { reserved for future use }
  NumMsg     : System.LongInt;         { - ᠣ ࠢ HighMsg }
  HighMsg    : System.LongInt;         {  ᫥ ᠣ }
  SkipMsg    : System.LongInt;         {  騪: 㤠 稭 
                                         SkipMsg+1 ᫨ - ᠣ = MaxMsg }
  HighWater  : System.LongInt;         { UID ᫥ ᠣ }
  UID        : System.LongInt;         { 㭨  (⭮⥫쭮 ⮫쪮
                                         ⮩ )  ᫥饩 ᠣ }
  Base       : Array[1..80] Of Char;   {  ᠫ  ,  , 易⥫쭮 }
  FirstFrame : System.LongInt;         { 砫 ३ ࢮ ᠣ }
  LastFrame  : System.LongInt;         { 砫 ३ ᫥ ᠣ }
  FirstFree  : System.LongInt;         { 砫 ३ ࢮ ਡ⮩ ᠣ }
  LastFree   : System.LongInt;         { 砫 ३ ᫥ ਡ⮩ ᠣ }
  EndFrame   : System.LongInt;         {    ᠣ }
  MaxMsg     : System.LongInt;         {  ᫮ ᠣ,  㡨 }
  KeepDays   : System.Word;            { ᪮쪮  ࠭,  sqpack }
  SqHdrSize  : System.Word;            { ᥣ 1C }
  Rsvd2      : Array[1..124] Of Char;  { 㫨 }
 end;
{}
 tSquishFrame = record
  Id         : System.LongInt;         { id = 0xAFAE4453 ᥣ }
  NextFrame  : System.LongInt;         { ᫥騩 ३ }
  PrevFrame  : System.LongInt;         { ।騩 ३ }
  FrameLength: System.LongInt;         {  ᥣ ३ = MsgLength+⮪ }
  MsgLength  : System.LongInt;         {  ᠣ (娤+cib+⥫ ᠣ+1) }
  CIBLength  : System.LongInt;         {   ᠣ+1 }
  FrameType  : System.Word;            { ⨯ ३
                                         0 - ଠ;
                                         1 - ᢮;
                                         3 - 祭 ( ) }
  Rsvd       : System.Word;            {  }
 end;
{}
 tSquishMsgHdr = record
  Attr       : System.LongInt;         { ਡ ᠣ }
  OrigName   : Array[1..36] Of Char;   {  ࠢ⥫ }
  DestName   : Array[1..36] Of Char;   {  ⥫ }
  Subject    : Array[1..72] Of Char;   {  subject }
  OrigAddr   : tAddress;               {  ࠢ⥫ }
  DestAddr   : tAddress;               {  ⥫ }
  DateWritten: System.LongInt;         {  ᠭ }
  DateArrived: System.LongInt;         {    ᪢ }
  UTCoffset  : System.Word;            { ᬥ饭  ਭ ( ᯮ) }
  ReplyTo    : System.LongInt;         { ᫨ ⢥,  ࠢ UID' ᠣ,
                                           ⢥砥 }
  Replies    : Array[1..9] Of System.LongInt; {   㣨 ᠣ }
  UID        : System.Longint;         {  msgid, ⮫쪮  ᪢ }
  Date       : Array[1..20] Of Char;   {  }
 end;
{}
 tSquishIndex = record
  Offset     : System.Longint;         { ᬥ饭  sqd }
  Number     : System.Longint;         { UID ᠣ }
  Hash       : System.Longint;         { ? }
 end;
{( tSuiqshBase )}
 pSquishBase = ^tSquishBase;
 tSquishBase = object(tAbsBase)
  BaseHdr   : tSquishBaseHdr;
  MsgHdr    : tSquishMsgHdr;
  Frame     : tSquishFrame;
  Index     : tSquishIndex;
  IndexLink : pStream;
  constructor init;
  destructor  done; virtual;
  procedure   FillHeaders; virtual;

  function    LoadBaseHdr(fn: String; aShareMode: Word): Byte; virtual;
  function    SaveBaseHdr(fn: String; aShareMode: Word): Byte; virtual;
  procedure   AbsData2MsgHdr(var Msg: tAbsMsg; r: Boolean); virtual;
  function    LoadMsg(var Msg: tAbsMsg; Number: Longint): Byte; virtual;
  procedure   StreamReadKl(var CIB: tStream; var s: String);
  function    SaveMsg(var Msg: tAbsMsg; Number: Longint): Byte; virtual;
  procedure   StreamWriteKl(var CIB: tStream; s: String);
  function    DeleteMsg(Number: LongInt): Byte; virtual;
  function    MakeHash(Name: String): Longint;
  function    SwapLong(al: Longint): Longint;

  procedure   ResetAll; virtual;
 end;
{}
implementation
Uses Strings, Dos, rObjects, rCommon, rTime, rStrings;
{( tSuiqshBase )}
constructor tSquishBase.init;
 begin
  inherited init;
  IndexLink:=nil;
  FillChar(BaseHdr,SizeOf(BaseHdr),0);
  FillChar(MsgHdr,SizeOf(MsgHdr),0);
  FillChar(Index,SizeOf(Index),0);
  FillHeaders;
 end;
{}
destructor  tSquishBase.done;
 begin
  inherited done;
  FillChar(BaseHdr,SizeOf(BaseHdr),0);
  FillChar(MsgHdr,SizeOf(MsgHdr),0);
  FillChar(Index,SizeOf(Index),0);
  FillHeaders;
  DisposeObj(IndexLink);
  DisposeObj(MainLink);
 end;
{}
procedure   tSquishBase.FillHeaders;
 begin
  with BaseHdr do
   begin
    Len:=$100;
    if UID=0 then UID:=2;
    SqHdrSize:=$1C;
    if EndFrame=0 then EndFrame:=$100;
   end;
  with Frame do
   begin
    if ID<>SqID then ID:=SqID;
   end;
  end;
{}
function    tSquishBase.LoadBaseHdr;
 begin
  LoadBaseHdr:=inherited LoadBaseHdr(fn,aShareMode);
  DisposeObj(MainLink);
  DisposeObj(IndexLink);
  DisposeObj(LastLink);
  MainLink:=New(pBufStream,Init(GetPS(BaseFileName)+SqDataExt,stOpen or ShareMode,BlockSize));
  IndexLink:=New(pBufStream,Init(GetPS(BaseFileName)+SqIndexExt,stOpen or ShareMode,BlockSize));
  if Exist(GetPS(BaseFileName)+SqLastReadExt) then
  LastLink:=New(pBufStream,Init(GetPS(BaseFileName)+SqLastReadExt,stOpen or ShareMode,BlockSize))
  else LastLink:=New(pBufStream,Init(GetPS(BaseFileName)+SqLastReadExt,stCreate or ShareMode,BlockSize));
  if (MainLink^.Status<>0) or (IndexLink^.Status<>0) then
   begin
    BaseStatus:=bsOpenError;
    DisposeObj(MainLink);
    DisposeObj(IndexLink);
    DisposeObj(LastLink);
    exit;
   end;
  MainLink^.Read(BaseHdr,SizeOf(BaseHdr));
  if MainLink^.Status<>0 then
   begin
    BaseStatus:=bsOpenError;
    DisposeObj(MainLink);
    DisposeObj(IndexLink);
    DisposeObj(LastLink);
    exit;
   end else BaseStatus:=bsOpened;
  Count:=BaseHdr.NumMsg;
  LoadBaseHdr:=0;
 end;
{}
function    tSquishBase.SaveBaseHdr;
 begin
  SaveBaseHdr:=inherited SaveBaseHdr(fn,aShareMode);
  DisposeObj(MainLink);
  DisposeObj(IndexLink);
  DisposeObj(LastLink);
  IndexLink:=New(pBufStream,Init(GetPS(BaseFileName)+SqIndexExt,stCreate or ShareMode,BlockSize));
  MainLink:=New(pBufStream,Init(GetPS(BaseFileName)+SqDataExt,stCreate or ShareMode,BlockSize));
  LastLink:=New(pBufStream,Init(GetPS(BaseFileName)+SqLastReadExt,stCreate or ShareMode,BlockSize));
  if (MainLink^.Status<>0) or (IndexLink^.Status<>0) then
   begin
    BaseStatus:=bsOpenError;
    DisposeObj(MainLink);
    DisposeObj(IndexLink);
    exit;
   end;
  with BaseHdr do
   begin
    Len:=$100;
    SqHdrSize:=$1C;
    EndFrame:=$100;
    FirstFrame:=$100;
    LastFrame:=0;
    HighWater:=1;
    UID:=2;
   end;
  MainLink^.Write(BaseHdr,SizeOf(BaseHdr));
  Count:=BaseHdr.NumMsg;
  BaseStatus:=bsOpened;
  SaveBaseHdr:=0;
 end;
{}
procedure   tSquishBase.AbsData2MsgHdr;
 var
  x: Longint;
 begin
  inherited AbsData2MsgHdr(Msg,r);
  if R then with Msg.AbsMsgData do
   begin
    ReallocStr(OrigName,StrPas(@MsgHdr.OrigName));
    ReallocStr(DestName,StrPas(@MsgHdr.DestName));
    ReallocStr(Subject,StrPas(@MsgHdr.Subject));
    Date:=StrPas(@MsgHdr.Date);
    OrigZone:=MsgHdr.OrigAddr.Zone;
    DestZone:=MsgHdr.DestAddr.Zone;
    OrigNode:=MsgHdr.OrigAddr.Node;
    DestNode:=MsgHdr.DestAddr.Node;
    OrigNet:=MsgHdr.OrigAddr.Net;
    DestNet:=MsgHdr.DestAddr.Net;
    OrigPoint:=MsgHdr.OrigAddr.Point;
    DestPoint:=MsgHdr.DestAddr.Point;
    Attr:=MsgHdr.Attr;

    UnPackTime(SwapLong(MsgHdr.DateWritten),DateWritten);
    UnPackTime(SwapLong(MsgHdr.DateArrived),DateArrived);
    if (Date='') then Date:=GetFscTime(DateArrived);

    UTCoffset:=MsgHdr.UTCoffset;
    ReplyTo:=MsgHdr.ReplyTo;
    for x:=1 to 9 do Replies[x]:=MsgHdr.Replies[x];
    UID:=BaseHdr.UID;
    if (MsgHdr.Attr and sqnflRcv<>0) then TimesRead:=1 else TimesRead:=0;
   end
  else with MsgHdr do
   begin
    if (Msg.AbsMsgData.Date='') then Msg.AbsMsgData.Date:=GetFscTime(Msg.AbsMsgData.DateArrived);
    StrPCopy(@OrigName,GetPS(Msg.AbsMsgData.OrigName));
    StrPCopy(@DestName,GetPS(Msg.AbsMsgData.DestName));
    StrPCopy(@Subject,GetPS(Msg.AbsMsgData.Subject));
    StrPCopy(@Date,Msg.AbsMsgData.Date);
    DestAddr.Zone:=Msg.AbsMsgData.DestZone;
    OrigAddr.Zone:=Msg.AbsMsgData.OrigZone;
    DestAddr.Node:=Msg.AbsMsgData.DestNode;
    OrigAddr.Node:=Msg.AbsMsgData.OrigNode;
    DestAddr.Net:=Msg.AbsMsgData.DestNet;
    OrigAddr.Net:=Msg.AbsMsgData.OrigNet;
    DestAddr.Point:=Msg.AbsMsgData.DestPoint;
    OrigAddr.Point:=Msg.AbsMsgData.OrigPoint;
    Attr:=Msg.AbsMsgData.Attr;

    PackTime(Msg.AbsMsgData.DateWritten,DateWritten);
    PackTime(Msg.AbsMsgData.DateArrived,DateArrived);

    DateWritten:=SwapLong(DateWritten);
    DateArrived:=SwapLong(DateArrived);
    UTCoffset:=Msg.AbsMsgData.UTCoffset;
    ReplyTo:=Msg.AbsMsgData.ReplyTo;
    for x:=1 to 9 do Replies[x]:=Msg.AbsMsgData.Replies[x];
    UID:=Msg.AbsMsgData.UID;
    if Boolean(Msg.AbsMsgData.TimesRead) then Attr:=Attr or sqnflRcv else Attr:=Attr and not sqnflRcv;
   end;
 end;
{}
function    tSquishBase.LoadMsg;
 var
  CIB: pStream;
  s1: String;
 begin
  LoadMsg:=inherited LoadMsg(Msg,Number);
  if (BaseStatus<>bsOpened) then exit;
  if @Msg=nil then Exit;
  if not ExistMsg(Number) then exit;
  with IndexLink^ do
   begin
    Seek((Number-1)*SizeOf(tSquishIndex));
    Read(Index,SizeOf(Index));
   end;
  if Index.Offset>MainLink^.GetSize then exit;
  with MainLink^ do
   begin
    Seek(Index.Offset);
    Read(Frame,SizeOf(Frame));
    Read(MsgHdr,SizeOf(MsgHdr));
   end;
  If Frame.ID<>SqID then
   begin
    Msg.MsgStatus:=msEmpty;
    exit;
   end;
  Msg.FreeMessage;
  Msg.FillHeaders;
  AbsData2MsgHdr(Msg,True);
  CIB:=New(pMemoryStream,Init(0,BlockSize));
  with CIB^ do
   begin
    CopyFrom(MainLink^,Frame.CIBLength);
    Seek(GetSize-1);
    Truncate;
    Seek(0);
   end;
  with Msg do
   repeat
   StreamReadKl(CIB^,s1);
   if UpStr(Copy(S1,1,Length(klINTL)))=UpStr(klINTL) then
    begin
     ReallocStr(Msg.AbsMsgData.INTL,Copy(S1,Length(klINTL)+1,255));
     System.Delete(s1,1,1);
    end;
   if UpStr(Copy(S1,1,Length(klTOPT)))=UpStr(klTOPT) then
    begin
     Msg.AbsMsgData.DestPoint:=CToN(Copy(S1,Length(klTOPT)+1,255));
     System.Delete(s1,1,1);
    end;
   if UpStr(Copy(S1,1,Length(klFMPT)))=UpStr(klFMPT) then
    begin
     Msg.AbsMsgData.OrigPoint:=CToN(Copy(S1,Length(klFMPT)+1,255));
     System.Delete(s1,1,1);
    end;
   if UpStr(Copy(S1,1,Length(klMsgID)))=UpStr(klMsgID) then
    begin
     ReallocStr(Msg.AbsMsgData.MsgID,Copy(S1,Length(klMsgID)+1,255));
     System.Delete(s1,1,1);
    end;
   if UpStr(Copy(S1,1,Length(klReply)))=UpStr(klReply) then
    begin
     ReallocStr(Msg.AbsMsgData.Reply,Copy(S1,Length(klReply)+1,255));
     System.Delete(s1,1,1);
    end;
   if UpStr(Copy(S1,1,Length(klFlags)))=UpStr(klFlags) then
    begin
     ReallocStr(Msg.AbsMsgData.Flags,Copy(S1,Length(klFlags)+1,255));
     System.Delete(s1,1,1);
    end;
   if UpStr(Copy(S1,1,Length(klPID)))=UpStr(klPID) then
    begin
     ReallocStr(Msg.AbsMsgData.PID,Copy(S1,Length(klPID)+1,255));
     System.Delete(s1,1,1);
    end;
   if UpStr(Copy(S1,1,Length(klVia)))=UpStr(klVia) then with Msg.ViaCol^ do
    begin
     Insert(New(PKludge,Init(klVia,Copy(S1,Length(klVia)+1,255))));
     System.Delete(s1,1,1);
    end;
   if UpStr(Copy(S1,1,Length(klRecd)))=UpStr(klRecd) then with Msg.ViaCol^ do
    begin
     Insert(New(PKludge,Init(klRecd,Copy(S1,Length(klRecd)+1,255))));
     System.Delete(s1,1,1);
    end;
   if UpStr(Copy(S1,1,Length(klForw)))=UpStr(klForw) then with Msg.ViaCol^ do
    begin
     Insert(New(PKludge,Init(klForw,Copy(S1,Length(klForw)+1,255))));
     System.Delete(s1,1,1);
    end;
   if (UpStr(Copy(S1,1,Length(klOther)))=UpStr(klOther)) then with Msg.OtherCol^ do
    begin
     Insert(New(PKludge,Init(klOther,Copy(S1,Length(klOther)+1,255))));
     System.Delete(s1,1,1);
    end;
   until (CIB^.Status<>stOK) or (CIB^.GetSize=CIB^.GetPos);
  DisposeObj(CIB);
  LoadMsgBody(Msg,MainLink^.GetPos,MainLink^.GetPos+Frame.MsgLength-SizeOf(tSquishMsgHdr)-Frame.CIBLength);
  Msg.MsgBody^.Reset;
  Msg.ProcessFlags(true);
  Msg.ParseKludges;
  Msg.MsgStatus:=msLoaded;
  LoadMsg:=0;
 end;
{}
procedure   tSquishBase.StreamReadKl;
 const
  cr: Char = #1;
 var
  c,c1: Char;
 begin
  if @CIB=nil then Exit;
  s:='';
  repeat
   CIB.Read(c,1);
   if (CIB.Status=stOK) and (c<>cr) then s:=s+c;
  until ((CIB.Status<>stOK) or (c=cr));
  if CIB.Status=stOK then
   begin
    CIB.Read(c1,1);
    if ((c1<>cr)) then CIB.Seek(CIB.GetPos-1);
   end;
  if CIB.Status<>0 then
   begin
    CIB.Reset;
    CIB.Seek(CIB.GetSize);
   end;
  if s<>'' then s:=#1+s;
 end;
{}
function    tSquishBase.SaveMsg;
 const
  zr: char = #0;
 var
  CIB,Body: pStream;
  x: Longint;
  PrevF,NextF: tSquishFrame;
  PrevI,NextI: tSquishIndex;
  Killed: Boolean;
 begin
  if (BaseStatus<>bsOpened) then exit;
  if @Msg=nil then Exit;
{ kill message [if exist] }
  Killed:=False;
  if ExistMsg(Number) then
   begin
    DeleteMsg(Number);
    Killed:=True;
   end;
  if Number>Count+1 then Number:=Count+1;
  SaveMsg:=inherited SaveMsg(Msg,Number);
  Msg.ProcessFlags(false);
  AbsData2MsgHdr(Msg,false);
{ filling control information buffer }
  CIB:=New(pMemoryStream,Init(0,BlockSize));
  with Msg.AbsMsgData do
   begin
    if (GetPS(Area)='') then
     begin
      if (OrigPoint<>0) then StreamWriteKl(CIB^,klFMPT+NToC(OrigPoint));
      if (DestPoint<>0) then StreamWriteKl(CIB^,klTOPT+NToC(DestPoint));
      if (GetPS(INTL)<>'') then StreamWriteKl(CIB^,klINTL+GetPS(INTL));
     end;
    if (GetPS(MsgID)<>'') then StreamWriteKl(CIB^,klMsgID+GetPS(MsgID));
    if (GetPS(Reply)<>'') then StreamWriteKl(CIB^,klReply+GetPS(Reply));
    if (GetPS(Flags)<>'') then StreamWriteKl(CIB^,klFlags+GetPS(Flags));
    if (GetPS(PID)<>'') then StreamWriteKl(CIB^,klPID+GetPS(PID));
    if (GetPS(TID)<>'') then StreamWriteKl(CIB^,klTID+GetPS(TID));
    if (Msg.OtherCol^.Count>0) then for x:=0 to Msg.OtherCol^.Count-1 do with PKludge(Msg.OtherCol^.At(x))^ do
    StreamWriteKl(CIB^,GetPS(klName)+GetPS(kl));
   end;
  CIB^.Write(zr,SizeOf(zr));
{ filling message body [with kludges] }
  Body:=New(pMemoryStream,Init(0,BlockSize));
  Msg.MsgBody^.Reset;
  Msg.MsgBody^.Seek(0);
  Body^.CopyFrom(Msg.MsgBody^,Msg.MsgBody^.GetSize);
  with Msg.AbsMsgData do
   begin
    if (GetPS(TearLine)<>'') then StreamWriteLn(Body^,bTearLine+GetPS(TearLine),cr);
    if (GetPS(Origin)<>'') or (GetPS(Area)<>'') then
    StreamWriteLn(Body^,bOrigin+GetPS(Origin)+Bracket1+Msg.GetSourceAddress+Bracket2,cr);
   end;
{ path and seenby}
  with Msg.SeenBy^ do if Count>0 then for x:=0 to Count-1 do StreamWriteLn(Body^,klSeenBy+GetPS(At(x)),cr);
  with Msg.Path^ do if Count>0 then for x:=0 to Count-1 do StreamWriteLn(Body^,klPath+GetPS(At(x)),cr);
{ via }
  if Msg.ViaCol^.Count>0 then for x:=0 to Msg.ViaCol^.Count-1 do with PKludge(Msg.ViaCol^.At(x))^ do
  StreamWriteLn(Body^,GetPS(klName)+GetPS(kl),cr);
  Body^.Write(zr,SizeOf(zr));
{ change nearest frames [if exist] }
  FillChar(PrevF,SizeOf(PrevF),#0);
  FillChar(NextF,SizeOf(NextF),#0);
  FillChar(PrevI,SizeOf(PrevI),#0);
  FillChar(NextI,SizeOf(NextI),#0);
  if ExistMsg(Number-1) then
   begin
    IndexLink^.Seek((Number-1-1)*SizeOf(tSquishIndex));
    IndexLink^.Read(PrevI,SizeOf(PrevI));
    MainLink^.Seek(PrevI.Offset);
    MainLink^.Read(PrevF,SizeOf(PrevF));
    PrevF.NextFrame:=BaseHdr.EndFrame;
    MainLink^.Seek(PrevI.Offset);
    MainLink^.Write(PrevF,SizeOf(PrevF));
   end;
  if ExistMsg(Number) then
   begin
    IndexLink^.Seek((Number-1)*SizeOf(tSquishIndex));
    IndexLink^.Read(NextI,SizeOf(NextI));
    MainLink^.Seek(NextI.Offset);
    MainLink^.Read(NextF,SizeOf(NextF));
    NextF.PrevFrame:=BaseHdr.EndFrame;
    MainLink^.Seek(NextI.Offset);
    MainLink^.Write(NextF,SizeOf(NextF));
   end;
{ fill new frame }
  if Killed then Inc(Count);
  with Frame do
   begin
    ID:=SqID;
    NextFrame:=NextI.Offset;
    PrevFrame:=PrevI.Offset;
    FrameLength:=SizeOf(tSquishMsgHdr)+CIB^.GetSize+Body^.GetSize;
    MsgLength:=FrameLength;
    CIBLength:=CIB^.GetSize;
    FrameType:=0;
    Rsvd:=0;
   end;
{ save message }
  with MainLink^ do
   begin
    Seek(BaseHdr.EndFrame);
    Write(Frame,SizeOf(Frame));
    Write(MsgHdr,SizeOf(MsgHdr));
    CIB^.Seek(0);
    Body^.Seek(0);
    CopyFrom(CIB^,CIB^.GetSize);
    CopyFrom(Body^,Body^.GetSize);
   end;
{ fill header }
  with BaseHdr do
   begin
    Index.Offset:=EndFrame;
    Index.Hash:=MakeHash(Msg.GetDestinationName);
    if Number>=Count then LastFrame:=EndFrame else Index.Number:=PrevI.Number+1;
    if Number=1 then FirstFrame:=EndFrame;
    if Number>Count then
     begin
      Index.Number:=UID;
      Inc(Count);
      HighWater:=MsgHdr.UID;
      Inc(UID);
     end;
    EndFrame:=MainLink^.GetSize;
    Inc(NumMsg);
    Inc(HighMsg);
   end;
{ save header }
  with MainLink^ do
   begin
    MainLink^.Seek(0);
    MainLink^.Write(BaseHdr,SizeOf(BaseHdr));
   end;
{ make index }
  InsertStream(IndexLink^,(Number-1)*SizeOf(tSquishIndex),SizeOf(tSquishIndex));
  IndexLink^.Seek((Number-1)*SizeOf(tSquishIndex));
  IndexLink^.Write(Index,SizeOf(Index));

  DisposeObj(CIB);
  DisposeObj(Body);
  SaveMsg:=0;
  Msg.MsgStatus:=msSaved;
 end;
{}
procedure   tSquishBase.StreamWriteKl;
 begin
  if @CIB=nil then Exit;
  CIB.Write(s[1],Length(s));
 end;
{}
function    tSquishBase.DeleteMsg;
 var
  TempFrame: tSquishFrame;
  LnkOfs: Longint;
 begin
  DeleteMsg:=inherited DeleteMsg(Number);
  if (BaseStatus<>bsOpened) then exit;
  if not ExistMsg(Number) then exit;
  LnkOfs:=(Number-1)*SizeOf(tSquishIndex);
  with IndexLink^ do
   begin
    Seek(LnkOfs);
    Read(Index,SizeOf(Index));
   end;
  if LnkOfs=0 then CutStream(IndexLink^,LnkOfs-1,LnkOfs+SizeOf(tSquishIndex)) else
  CutStream(IndexLink^,LnkOfs-1,LnkOfs+SizeOf(tSquishIndex)-1);
  with MainLink^ do
   begin
    Seek(Index.Offset);
    Read(Frame,SizeOf(Frame));
    Frame.FrameType:=1;
    Seek(Index.Offset);
    Write(Frame,SizeOf(Frame));
    if Frame.PrevFrame<>0 then
     begin
      Seek(Frame.PrevFrame);
      Read(TempFrame,SizeOf(TempFrame));
      TempFrame.NextFrame:=Frame.NextFrame;
      Seek(Frame.PrevFrame);
      Write(TempFrame,SizeOf(TempFrame));
     end else BaseHdr.FirstFrame:=Frame.NextFrame;
    if Frame.NextFrame<>0 then
     begin
      Seek(Frame.NextFrame);
      Read(TempFrame,SizeOf(TempFrame));
      TempFrame.PrevFrame:=Frame.PrevFrame;
      Seek(Frame.NextFrame);
      Write(TempFrame,SizeOf(TempFrame));
     end else BaseHdr.LastFrame:=Frame.PrevFrame;
   end;
  with BaseHdr do
   begin
    Dec(NumMsg);
    Dec(HighMsg);
    if (Index.Offset<FirstFree) or (FirstFree<=0) then
     begin
      MainLink^.Seek(FirstFree);
      MainLink^.Read(TempFrame,SizeOf(TempFrame));
      TempFrame.PrevFrame:=Index.Offset;
      MainLink^.Seek(FirstFree);
      MainLink^.Write(TempFrame,SizeOf(TempFrame));
      Frame.NextFrame:=FirstFree;
      Frame.PrevFrame:=0;
      FirstFree:=Index.Offset;
     end;
    if (Index.Offset>LastFree) then
     begin
      MainLink^.Seek(LastFree);
      MainLink^.Read(TempFrame,SizeOf(TempFrame));
      TempFrame.NextFrame:=Index.Offset;
      MainLink^.Seek(LastFree);
      MainLink^.Write(TempFrame,SizeOf(TempFrame));
      Frame.PrevFrame:=LastFree;
      Frame.NextFrame:=0;
      LastFree:=Index.Offset;
     end;
    if (Index.Offset<LastFree) and (Index.Offset>FirstFree) then
     begin
      MainLink^.Seek(LastFree);
      MainLink^.Read(TempFrame,SizeOf(TempFrame));
      TempFrame.NextFrame:=Index.Offset;
      MainLink^.Seek(LastFree);
      MainLink^.Write(TempFrame,SizeOf(TempFrame));
      Frame.PrevFrame:=LastFree;
      Frame.NextFrame:=0;
      LastFree:=Index.Offset;
     end;
   end;
  MainLink^.Seek(0);
  MainLink^.Write(BaseHdr,SizeOf(BaseHdr));
  MainLink^.Seek(Index.Offset);
  MainLink^.Write(Frame,SizeOf(Frame));
  Dec(Count);
  DeleteMsg:=0;
 end;
{}
function    tSquishBase.MakeHash;
 var
  K: Byte;
  Hash, Tmp: Longint;
 begin
  Hash:=0;
  for K:=1 to Length(Name) do
   begin
    Hash:=(Hash shl 4)+Byte(LoCase(Name[K]));
    Tmp:=Hash and $F0000000;
    if Tmp<>0 then Hash:=(Hash or (Tmp shr 24)) or Tmp;
   end;
  MakeHash:=Hash and $7FFFFFFF;
 end;
{}
function    tSquishBase.SwapLong;
 begin
  SwapLong:=(al shr 16) + ((al and $FFFF) shl 16);
 end;
{}
procedure   tSquishBase.ResetAll;
 begin
  inherited ResetAll;
  IndexLink^.Reset;
 end;
{}
end.
